// Code generated by pulumi-language-go DO NOT EDIT.
// *** WARNING: Do not edit by hand unless you're certain you know what you are doing! ***

package pkg

import (
	"context"
	"reflect"

	"example.com/pulumi-pkg/sdk/go/pkg/internal"
	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
)

// A test resource that generates a random string of a given length and with an optional prefix.
type Random struct {
	pulumi.CustomResourceState

	// The length of the random string (not including the prefix, if any).
	Length pulumi.IntPtrOutput `pulumi:"length"`
	// An optional prefix.
	Prefix pulumi.StringPtrOutput `pulumi:"prefix"`
	// A random string.
	Result pulumi.StringPtrOutput `pulumi:"result"`
}

// NewRandom registers a new resource with the given unique name, arguments, and options.
func NewRandom(ctx *pulumi.Context,
	name string, args *RandomArgs, opts ...pulumi.ResourceOption) (*Random, error) {
	if args == nil {
		args = &RandomArgs{}
	}

	opts = internal.PkgResourceDefaultOpts(opts)
	ref, err := internal.PkgGetPackageRef(ctx)
	if err != nil {
		return nil, err
	}
	var resource Random
	err = ctx.RegisterPackageResource("pkg:index:Random", name, args, &resource, ref, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// GetRandom gets an existing Random resource's state with the given name, ID, and optional
// state properties that are used to uniquely qualify the lookup (nil if not required).
func GetRandom(ctx *pulumi.Context,
	name string, id pulumi.IDInput, state *RandomState, opts ...pulumi.ResourceOption) (*Random, error) {
	var resource Random
	ref, err := internal.PkgGetPackageRef(ctx)
	if err != nil {
		return nil, err
	}
	err = ctx.ReadPackageResource("pkg:index:Random", name, id, state, &resource, ref, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// Input properties used for looking up and filtering Random resources.
type randomState struct {
}

type RandomState struct {
}

func (RandomState) ElementType() reflect.Type {
	return reflect.TypeOf((*randomState)(nil)).Elem()
}

type randomArgs struct {
	// The length of the random string (not including the prefix, if any).
	Length *int `pulumi:"length"`
	// An optional prefix.
	Prefix *string `pulumi:"prefix"`
}

// The set of arguments for constructing a Random resource.
type RandomArgs struct {
	// The length of the random string (not including the prefix, if any).
	Length pulumi.IntPtrInput
	// An optional prefix.
	Prefix pulumi.StringPtrInput
}

func (RandomArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*randomArgs)(nil)).Elem()
}

type RandomInput interface {
	pulumi.Input

	ToRandomOutput() RandomOutput
	ToRandomOutputWithContext(ctx context.Context) RandomOutput
}

func (*Random) ElementType() reflect.Type {
	return reflect.TypeOf((**Random)(nil)).Elem()
}

func (i *Random) ToRandomOutput() RandomOutput {
	return i.ToRandomOutputWithContext(context.Background())
}

func (i *Random) ToRandomOutputWithContext(ctx context.Context) RandomOutput {
	return pulumi.ToOutputWithContext(ctx, i).(RandomOutput)
}

type RandomOutput struct{ *pulumi.OutputState }

func (RandomOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**Random)(nil)).Elem()
}

func (o RandomOutput) ToRandomOutput() RandomOutput {
	return o
}

func (o RandomOutput) ToRandomOutputWithContext(ctx context.Context) RandomOutput {
	return o
}

// The length of the random string (not including the prefix, if any).
func (o RandomOutput) Length() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *Random) pulumi.IntPtrOutput { return v.Length }).(pulumi.IntPtrOutput)
}

// An optional prefix.
func (o RandomOutput) Prefix() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *Random) pulumi.StringPtrOutput { return v.Prefix }).(pulumi.StringPtrOutput)
}

// A random string.
func (o RandomOutput) Result() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *Random) pulumi.StringPtrOutput { return v.Result }).(pulumi.StringPtrOutput)
}

func init() {
	pulumi.RegisterInputType(reflect.TypeOf((*RandomInput)(nil)).Elem(), &Random{})
	pulumi.RegisterOutputType(RandomOutput{})
}
